/* 
* -cr_beg-
* ********************************************************************
* Licensed Materials - Property of IBM
* Restricted Materials of IBM
* 5724-U38, 5724-U39, 5724-U48, 5655-V17, 5655-V19, 5655-V35, 5655-V37
*  Copyright IBM Corp. 2013
* ********************************************************************
* -cr_end-
*/ 
#define SQL_TEXT Latin_Text
#include <sqltypes_td.h>

#include "ODPPTeraUDF.h"

void OptimMaskNum18Num18(DECIMAL8 *Field1,
                         VARCHAR_LATIN *ProviderStr,
                         DECIMAL8 *result,
                         int *Field1NullInd,
                         int *ProviderStrNullInd,
                         int *resultNullInd,
                         char sqlstate[6],
                         SQL_TEXT functionName[],
                         SQL_TEXT specificName[],
                         SQL_TEXT errorMessage[256])
{
   ODPPTeraMaskSQLCA sqlca;
   BIGINT Field1AsInt64;
   BIGINT ResultAsInt64;

   ODPPTeraMaskInitSQLCALatin(&sqlca, sqlstate, functionName, specificName, errorMessage);

   if (*ProviderStrNullInd)
   {
      *resultNullInd = -1;
      return;
   }

   Field1AsInt64 = (*Field1NullInd) ? 0 : (((BIGINT) Field1->high) << 32) + Field1->low;
   ODPPTeraMaskDec8(ProviderStr, Field1AsInt64, *Field1NullInd, 18, 0, &ResultAsInt64, resultNullInd, &sqlca);
   if (! *resultNullInd)
   {
      result->low = (unsigned int) ResultAsInt64;
      result->high = (int) ((ResultAsInt64 >> 32) & 0xFFFF);
   }
   return;
}
